
#include "IcomSerialRX.h"
/// the global where frequency messages are sent..
extern void onMessageGlobal(IcomMessage *);

void
IcomSerialRX::checkReceive(void)
{
    while(true)
    {
    	int iRead = Serial.read();
    	if (iRead < 0  ) return;
    	byte bin = static_cast<byte> (iRead);
    	byte res = add(bin);
    	if (res <= 1) return;  // nothing to do
    	if (res == 3)
    	{
    		if (imReceive.ValidateReceiveMessage())
    			::onMessageGlobal(&imReceive);
    	}
    	imReceive.setMTY();
    }
}


byte
IcomSerialRX::add(const byte x)
{
	byte bRet = 0;

	if (stReceive.isTimedout())
	{
		//  on time out
		imReceive.setInUse();  /// sets m_Counter = 0xff
		flagClear(isValidStartFlag);
		bRet = 1;
	}

	if ( (m_lastin == icomMessageStartByte) && (x == icomMessageStartByte) )
	{
		flagSet(isValidStartFlag);
		imReceive.setMTY(); // sets m_Counter = 0   but it will increment 2 lines down
	}
	m_lastin = x;
	if (! imReceive.add(x))
	{
		flagClear(isValidStartFlag);
		bRet = 2;
	}
	if ( x == icomMessageStopByte)
	{
		bRet = flagRead(isValidStartFlag) ? 3 : 4;
		flagClear(isValidStartFlag);
	}

	stReceive.start(icomMessageReceiveTimeOutinMS);
	return bRet;
}
